# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

Summary:        JDiff - An HTML Report of API Differences
Name:           jdiff
Version:        1.1.0
Release:        1%{?dist}
Epoch:          0
License:        LGPL
URL:            http://javadiff.sourceforge.net/
Group:          Development/Testing
Source0:        %{name}-%{version}-src.zip
Source1:        %{name}-%{version}.pom
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  xerces-j2
Requires:       java >= 0:1.5.0
Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
JDiff is a Javadoc doclet which generates an HTML 
report of all the packages, classes, constructors, 
methods, and fields which have been removed, added 
or changed in any way, including their documentation, 
when two APIs are compared. This is very useful for 
describing exactly what has changed between two 
releases of a product. Only the API (Application 
Programming Interface) of each version is compared. 
It does not compare what the source code does when 
executed. 

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
%{summary}.

%package        manual
Summary:        Docs and examples for %{name}
Group:          Development/Documentation

%description    manual
%{summary}.


%prep
%setup -q -n %{name}-%{version}-src
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
ln -sf $(build-classpath xerces-j2) lib/xerces.jar

%build
export CLASSPATH=$(build-classpath \
junit)
ant -Dbuild.sysclasspath=first
javadoc -classpath lib/jdiff.jar:$JAVA_HOME/lib/tools.jar \
-d apidocs -sourcepath src -subpackages jdiff

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -dm 755 $RPM_BUILD_ROOT%{_javadir}
cp -p build/lib/%{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p build/lib/ant%{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/ant%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual and examples
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p build/%{name}-%{version}/*.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p build/%{name}-%{version}/*.xml $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p build/%{name}-%{version}/*.html $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p build/%{name}-%{version}/*.gif $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p build/%{name}-%{version}/*.java $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr examples $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/*.txt
%{_javadir}/*.jar
%{_mavendepmapfragdir}/*
%{_datadir}/maven2/poms/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Fri Mar 20 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.1.0-1.jpp5
- First JPP-5 release

* Thu Jul 13 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0.10-2jpp
- First JPP-1.7 release

* Tue Nov 08 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0.10-1jpp
- Upgrade to 1.0.10

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0.9-2jpp
- Rebuild with ant-1.6.2

* Fri Feb 13 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0.9-1jpp
- First JPackage release
